org.firebirdsql.jdbc

## Class FBStatement

- java.lang.Object
- - org.firebirdsql.jdbc.FBStatement

- All Implemented Interfaces:
    java.lang.AutoCloseable, java.sql.Statement, java.sql.Wrapper, FirebirdStatement, Synchronizable
  Direct Known Subclasses:
    AbstractPreparedStatement

      public class FBStatement
      extends java.lang.Object
      implements FirebirdStatement, Synchronizable

  The object used for executing a static SQL statement and obtaining the results produced by it.

  Only one `ResultSet` object per `Statement` object can be open at any point in time. Therefore, if the reading of one `ResultSet` object is interleaved with the reading of another, each must have been generated by different `Statement` objects. All statement `execute` methods implicitly close a statement's current `ResultSet` object if an open one exists.

  Author:
    David Jencks, Mark Rotteveel
  See Also:
    `Connection.createStatement()`, `ResultSet`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `FBStatement.StatementResult` The current result of a statement.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `completed`
    `protected FBConnection` | `connection`
    `protected FBStatement.StatementResult` | `currentStatementResult`
    `protected FbStatement` | `fbStatement`
    `protected int` | `fetchSize`
    `protected java.sql.SQLWarning` | `firstWarning`
    `protected GDSHelper` | `gdsHelper`
    `protected boolean` | `isSingletonResult`
    `protected static JdbcVersionSupport` | `jdbcVersionSupport`
    `protected int` | `maxRows`
    `protected java.util.List<RowValue>` | `specialResult`
    `protected FBObjectListener.StatementListener` | `statementListener`

    - ### Fields inherited from interface java.sql.Statement

      `CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `FBStatement(GDSHelper c, int rsType, int rsConcurrency, int rsHoldability, FBObjectListener.StatementListener statementListener)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addBatch(java.lang.String sql)` Adds an SQL command to the current batch of commmands for this `Statement` object.
    `protected void` | `addWarning(java.sql.SQLWarning warning)`
    `void` | `cancel()`
    `protected void` | `checkValidity()` Check if this statement is valid.
    `void` | `clearBatch()` Makes the set of commands in the current batch empty.
    `void` | `clearWarnings()` Clears all the warnings reported on this `Statement` object.
    `void` | `close()` Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.
    `void` | `closeOnCompletion()`
    `void` | `completeStatement()`
    `void` | `completeStatement(CompletionReason reason)`
    `protected StatementListener` | `createStatementListener()` Creates the `StatementListener` to be associated with the instance of `FbStatement` created for this `FBStatement` or subclasses.
    `java.lang.String` | `enquoteIdentifier(java.lang.String identifier, boolean alwaysQuote)` Returns a SQL identifier.
    `java.lang.String` | `enquoteLiteral(java.lang.String val)` Returns a `String` enclosed in single quotes.
    `java.lang.String` | `enquoteNCharLiteral(java.lang.String val)`
    `boolean` | `equals(java.lang.Object other)`
    `boolean` | `execute(java.lang.String sql)` Executes an SQL statement that may return multiple results.
    `boolean` | `execute(java.lang.String sql, int autoGeneratedKeys)` Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval.
    `boolean` | `execute(java.lang.String sql, int[] columnIndexes)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `boolean` | `execute(java.lang.String sql, java.lang.String[] columnNames)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `int[]` | `executeBatch()` Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
    `protected java.util.List<java.lang.Long>` | `executeBatchInternal()`
    `protected boolean` | `executeImpl(java.lang.String sql)` Internal implementation of `execute(String)`, so it can be used for normal queries and for queries returning generated keys.
    `long[]` | `executeLargeBatch()`
    `long` | `executeLargeUpdate(java.lang.String sql)`
    `long` | `executeLargeUpdate(java.lang.String sql, int autoGeneratedKeys)`
    `long` | `executeLargeUpdate(java.lang.String sql, int[] columnIndexes)`
    `long` | `executeLargeUpdate(java.lang.String sql, java.lang.String[] columnNames)`
    `java.sql.ResultSet` | `executeQuery(java.lang.String sql)` Executes an SQL statement that returns a single `ResultSet` object.
    `int` | `executeUpdate(java.lang.String sql)` Executes an SQL `INSERT`, `UPDATE` or `DELETE` statement.
    `int` | `executeUpdate(java.lang.String sql, int autoGeneratedKeys)` Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.
    `int` | `executeUpdate(java.lang.String sql, int[] columnIndexes)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `int` | `executeUpdate(java.lang.String sql, java.lang.String[] columnNames)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
    `protected void` | `finalize()`
    `void` | `forgetResultSet()`
    `java.sql.Connection` | `getConnection()` Returns the `Connection` object that produced this `Statement` object.
    `java.sql.ResultSet` | `getCurrentResultSet()` Get current result set.
    `int` | `getDeletedRowsCount()` Get number of deleted rows.
    `int` | `getFetchDirection()`
    `int` | `getFetchSize()` Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object.
    `java.sql.ResultSet` | `getGeneratedKeys()` Retrieves any auto-generated keys created as a result of executing this `Statement` object.
    `int` | `getInsertedRowsCount()` Get number of inserted rows.
    `long` | `getLargeMaxRows()`
    `long` | `getLargeUpdateCount()`
    `java.lang.String` | `getLastExecutionPlan()` Get execution plan for the last executed statement.
    `int` | `getLocalStatementId()` The local statement id is intended to identify the statement for internal implementation purposes.
    `int` | `getMaxFieldSize()` Returns the maximum number of bytes allowed for any column value.
    `int` | `getMaxRows()` Retrieves the maximum number of rows that a `ResultSet` object can contain.
    `boolean` | `getMoreResults()` Moves to a `Statement` object's next result.
    `boolean` | `getMoreResults(int mode)`
    `int` | `getQueryTimeout()` Retrieves the number of seconds the driver will wait for a `Statement` object to execute.
    `java.sql.ResultSet` | `getResultSet()` Returns the current result as a `ResultSet` object.
    `java.sql.ResultSet` | `getResultSet(boolean metaDataQuery)`
    `int` | `getResultSetConcurrency()` Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.
    `int` | `getResultSetHoldability()`
    `int` | `getResultSetType()` Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.
    `java.lang.Object` | `getSynchronizationObject()` Get synchronization object.
    `int` | `getUpdateCount()` Returns the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned.
    `int` | `getUpdatedRowsCount()` Get number of updated rows.
    `java.sql.SQLWarning` | `getWarnings()` Retrieves the first warning reported by calls on this `Statement` object.
    `int` | `hashCode()`
    `boolean` | `hasOpenResultSet()` Check if this statement has open result set.
    `protected boolean` | `internalExecute(java.lang.String sql)`
    `boolean` | `isClosed()` Check if this statement was closed.
    `boolean` | `isCloseOnCompletion()`
    `protected boolean` | `isExecuteProcedureStatement(java.lang.String sql)` This method checks if supplied statement is executing procedure or it is generic statement.
    `protected boolean` | `isGeneratedKeyQuery()`
    `boolean` | `isPoolable()`
    `boolean` | `isSimpleIdentifier(java.lang.String identifier)` Retrieves whether `identifier` is a simple SQL identifier.
    `boolean` | `isValid()` Check if this statement is valid.
    `boolean` | `isWrapperFor(java.lang.Class<?> iface)`
    `protected java.lang.String` | `nativeSQL(java.lang.String sql)`
    `protected void` | `notifyStatementCompleted()`
    `protected void` | `notifyStatementCompleted(boolean success)`
    `protected void` | `notifyStatementStarted()`
    `protected void` | `notifyStatementStarted(boolean closeResultSet)`
    `protected void` | `prepareFixedStatement(java.lang.String sql)`
    `void` | `setCursorName(java.lang.String name)` Defines the SQL cursor name that will be used by subsequent `Statement` object `execute` methods.
    `void` | `setEscapeProcessing(boolean enable)` Sets escape processing on or off.
    `void` | `setFetchDirection(int direction)`
    `void` | `setFetchSize(int rows)` Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects genrated by this `Statement`.
    `void` | `setLargeMaxRows(long max)`
    `void` | `setMaxFieldSize(int max)` Sets the limit for the maximum number of bytes in a column to the given number of bytes.
    `void` | `setMaxRows(int max)` Sets the limit for the maximum number of rows that any `ResultSet` object can contain to the given number.
    `void` | `setPoolable(boolean poolable)`
    `void` | `setQueryTimeout(int seconds)` Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds.
    `protected int[]` | `toArray(java.util.Collection<java.lang.Long> updateCounts)` Convert collection of `Long` update counts into array of int.
    `protected long[]` | `toLargeArray(java.util.Collection<java.lang.Long> updateCounts)` Convert collection of `Integer` update counts into array of int.
    `<T> T` | `unwrap(java.lang.Class<T> iface)`

    - ### Methods inherited from class java.lang.Object

      `clone, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### jdbcVersionSupport

          protected static final JdbcVersionSupport jdbcVersionSupport

    - #### gdsHelper

          protected final GDSHelper gdsHelper

    - #### statementListener

          protected final FBObjectListener.StatementListener statementListener

    - #### fbStatement

          protected FbStatement fbStatement

    - #### completed

          protected boolean completed

    - #### firstWarning

          protected java.sql.SQLWarning firstWarning

    - #### currentStatementResult

          protected FBStatement.StatementResult currentStatementResult

    - #### isSingletonResult

          protected boolean isSingletonResult

    - #### specialResult

          protected final java.util.List<RowValue> specialResult

    - #### maxRows

          protected int maxRows

    - #### fetchSize

          protected int fetchSize

    - #### connection

          protected final FBConnection connection

  - ### Constructor Detail

    - #### FBStatement

          protected FBStatement(GDSHelper c,
                                int rsType,
                                int rsConcurrency,
                                int rsHoldability,
                                FBObjectListener.StatementListener statementListener)
                         throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

  - ### Method Detail

    - #### isValid

          public boolean isValid()

      Description copied from interface: `FirebirdStatement`
      Check if this statement is valid.
      Specified by:
        `isValid` in interface `FirebirdStatement`
      Returns:
        `true` if statement is valid and can be used to execute SQL.

    - #### getSynchronizationObject

          public final java.lang.Object getSynchronizationObject()

      Description copied from interface: `Synchronizable`
      Get synchronization object.
      Specified by:
        `getSynchronizationObject` in interface `Synchronizable`
      Returns:
        object, cannot be `null`.

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `java.lang.Object`
      Throws:
        `java.lang.Throwable`

    - #### completeStatement

          public void completeStatement()
                                 throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### completeStatement

          public void completeStatement(CompletionReason reason)
                                 throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### executeQuery

          public java.sql.ResultSet executeQuery(java.lang.String sql)
                                          throws java.sql.SQLException

      Executes an SQL statement that returns a single `ResultSet` object.
      Specified by:
        `executeQuery` in interface `java.sql.Statement`
      Parameters:
        `sql` - typically this is a static SQL `SELECT` statement
      Returns:
        a `ResultSet` object that contains the data produced by the given query; never `null`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### notifyStatementStarted

          protected void notifyStatementStarted()
                                         throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### notifyStatementStarted

          protected void notifyStatementStarted(boolean closeResultSet)
                                         throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### notifyStatementCompleted

          protected void notifyStatementCompleted()
                                           throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### notifyStatementCompleted

          protected void notifyStatementCompleted(boolean success)
                                           throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### executeUpdate

          public int executeUpdate(java.lang.String sql)
                            throws java.sql.SQLException

      Executes an SQL `INSERT`, `UPDATE` or `DELETE` statement. In addition, SQL statements that return nothing, such as SQL DDL statements, can be executed.
      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL `INSERT`, `UPDATE` or `DELETE` statement or an SQL statement that returns nothing
      Returns:
        either the row count for `INSERT`, `UPDATE` or `DELETE` statements, or 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### executeUpdate

          public int executeUpdate(java.lang.String sql,
                                   int autoGeneratedKeys)
                            throws java.sql.SQLException

      Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval. The driver will ignore the flag if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).
      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
        `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: `Statement.RETURN_GENERATED_KEYS` `Statement.NO_GENERATED_KEYS`
      Returns:
        either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement returns a `ResultSet` object, or the given constant is not one of those allowed
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
      Since:
        1.4

    - #### executeUpdate

          public int executeUpdate(java.lang.String sql,
                                   int[] columnIndexes)
                            throws java.sql.SQLException

      Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).
      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
        `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row
      Returns:
        either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object, or the second argument supplied to this method is not an `int` array whose elements are valid column indexes
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.4

    - #### executeUpdate

          public int executeUpdate(java.lang.String sql,
                                   java.lang.String[] columnNames)
                            throws java.sql.SQLException

      Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).
      Specified by:
        `executeUpdate` in interface `java.sql.Statement`
      Parameters:
        `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
        `columnNames` - an array of the names of the columns that should be returned from the inserted row
      Returns:
        either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object, or the second argument supplied to this method is not a `String` array whose elements are valid column names
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.4

    - #### execute

          public boolean execute(java.lang.String sql,
                                 int autoGeneratedKeys)
                          throws java.sql.SQLException

      Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval. The driver will ignore this signal if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

      The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

      Specified by:
        `execute` in interface `java.sql.Statement`
      Parameters:
        `sql` - any SQL statement
        `autoGeneratedKeys` - a constant indicating whether auto-generated keys should be made available for retrieval using the method `getGeneratedKeys`; one of the following constants: `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
      Returns:
        `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the second parameter supplied to this method is not `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`.
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method with a constant of Statement.RETURN_GENERATED_KEYS
      Since:
        1.4
      See Also:
        `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

    - #### execute

          public boolean execute(java.lang.String sql,
                                 int[] columnIndexes)
                          throws java.sql.SQLException

      Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      Under some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

      The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

      Specified by:
        `execute` in interface `java.sql.Statement`
      Parameters:
        `sql` - any SQL statement
        `columnIndexes` - an array of the indexes of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
      Returns:
        `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the elements in the `int` array passed to this method are not valid column indexes
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.4
      See Also:
        `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

    - #### execute

          public boolean execute(java.lang.String sql,
                                 java.lang.String[] columnNames)
                          throws java.sql.SQLException

      Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

      In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

      The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

      Specified by:
        `execute` in interface `java.sql.Statement`
      Parameters:
        `sql` - any SQL statement
        `columnNames` - an array of the names of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
      Returns:
        `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the elements of the `String` array passed to this method are not valid column names
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.4
      See Also:
        `getResultSet()`, `getUpdateCount()`, `getMoreResults()`, `getGeneratedKeys()`

    - #### getGeneratedKeys

          public java.sql.ResultSet getGeneratedKeys()
                                              throws java.sql.SQLException

      Retrieves any auto-generated keys created as a result of executing this `Statement` object. If this `Statement` object did not generate any keys, an empty `ResultSet` object is returned.

      Note:If the columns which represent the auto-generated keys were not specified, the JDBC driver implementation will determine the columns which best represent the auto-generated keys.

      Specified by:
        `getGeneratedKeys` in interface `java.sql.Statement`
      Returns:
        a `ResultSet` object containing the auto-generated key(s) generated by the execution of this `Statement` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
        `java.sql.SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
      Since:
        1.4

    - #### close

          public void close()
                     throws java.sql.SQLException

      Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed. It is generally good practice to release resources as soon as you are finished with them to avoid tying up database resources.

      Calling the method `close` on a `Statement` object that is already closed has no effect.

      Note: A `Statement` object is automatically closed when it is garbage collected. When a `Statement` object is closed, its current `ResultSet` object, if one exists, is also closed.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### isClosed

          public boolean isClosed()

      Check if this statement was closed. This is quick workaround to avoid additional `close()` in our cleanup code.
      Specified by:
        `isClosed` in interface `java.sql.Statement`
      Specified by:
        `isClosed` in interface `FirebirdStatement`
      Returns:
        `true` if this statement was already closed.

    - #### getMaxFieldSize

          public int getMaxFieldSize()
                              throws java.sql.SQLException

      Returns the maximum number of bytes allowed for any column value. This limit is the maximum number of bytes that can be returned for any column value. The limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, and `LONGVARCHAR` columns. If the limit is exceeded, the excess data is silently discarded.
      Specified by:
        `getMaxFieldSize` in interface `java.sql.Statement`
      Returns:
        the current max column size limit; zero means unlimited
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### setMaxFieldSize

          public void setMaxFieldSize(int max)
                               throws java.sql.SQLException

      Sets the limit for the maximum number of bytes in a column to the given number of bytes. This is the maximum number of bytes that can be returned for any column value. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, and `LONGVARCHAR` fields. If the limit is exceeded, the excess data is silently discarded. For maximum portability, use values greater than 256.
      Specified by:
        `setMaxFieldSize` in interface `java.sql.Statement`
      Parameters:
        `max` - the new max column size limit; zero means unlimited
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### getMaxRows

          public int getMaxRows()
                         throws java.sql.SQLException

      Retrieves the maximum number of rows that a `ResultSet` object can contain. If the limit is exceeded, the excess rows are silently dropped.
      Specified by:
        `getMaxRows` in interface `java.sql.Statement`
      Returns:
        the current max row limit; zero means unlimited
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### setMaxRows

          public void setMaxRows(int max)
                          throws java.sql.SQLException

      Sets the limit for the maximum number of rows that any `ResultSet` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.
      Specified by:
        `setMaxRows` in interface `java.sql.Statement`
      Parameters:
        `max` - the new max rows limit; zero means unlimited
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### setEscapeProcessing

          public void setEscapeProcessing(boolean enable)
                                   throws java.sql.SQLException

      Sets escape processing on or off. If escape scanning is on (the default), the driver will do escape substitution before sending the SQL to the database. Note: Since prepared statements have usually been parsed prior to making this call, disabling escape processing for prepared statements will have no effect.
      Specified by:
        `setEscapeProcessing` in interface `java.sql.Statement`
      Parameters:
        `enable` - `true` to enable; `false` to disable
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### getQueryTimeout

          public int getQueryTimeout()
                              throws java.sql.SQLException

      Retrieves the number of seconds the driver will wait for a `Statement` object to execute. If the limit is exceeded, a `SQLException` is thrown.
      Specified by:
        `getQueryTimeout` in interface `java.sql.Statement`
      Returns:
        the current query timeout limit in seconds; zero means unlimited
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### setQueryTimeout

          public void setQueryTimeout(int seconds)
                               throws java.sql.SQLException

      Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds. If the limit is exceeded, an `SQLException` is thrown.
      Specified by:
        `setQueryTimeout` in interface `java.sql.Statement`
      Parameters:
        `seconds` - the new query timeout limit in seconds; zero means unlimited
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### cancel

          public void cancel()
                      throws java.sql.SQLException

      Specified by:
        `cancel` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### getWarnings

          public java.sql.SQLWarning getWarnings()
                                          throws java.sql.SQLException

      Retrieves the first warning reported by calls on this `Statement` object. Subsequent `Statement` object warnings will be chained to this `SQLWarning` object.

      The warning chain is automatically cleared each time a statement is (re)executed.

      Note: If you are processing a `ResultSet` object, any warnings associated with reads on that `ResultSet` object will be chained on it.

      Specified by:
        `getWarnings` in interface `java.sql.Statement`
      Returns:
        the first `SQLWarning` object or `null`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### clearWarnings

          public void clearWarnings()
                             throws java.sql.SQLException

      Clears all the warnings reported on this `Statement` object. After a call to this method, the method `getWarnings` will return `null` until a new warning is reported for this `Statement` object.
      Specified by:
        `clearWarnings` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### setCursorName

          public void setCursorName(java.lang.String name)
                             throws java.sql.SQLException

      Defines the SQL cursor name that will be used by subsequent `Statement` object `execute` methods. This name can then be used in SQL positioned update/delete statements to identify the current row in the `ResultSet` object generated by this statement. If the database doesn't support positioned update/delete, this method is a noop. To insure that a cursor has the proper isolation level to support updates, the cursor's `SELECT` statement should be of the form 'select for update ...'. If the 'for update' phrase is omitted, positioned updates may fail.

      Note: By definition, positioned update/delete execution must be done by a different `Statement` object than the one which generated the `ResultSet` object being used for positioning. Also, cursor names must be unique within a connection.

      Specified by:
        `setCursorName` in interface `java.sql.Statement`
      Parameters:
        `name` - the new cursor name, which must be unique within a connection
      Throws:
        `java.sql.SQLException` - if a database access error occurs

    - #### execute

          public boolean execute(java.lang.String sql)
                          throws java.sql.SQLException

      Executes an SQL statement that may return multiple results. Under some (uncommon) situations a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string. The methods `execute`, `getMoreResults`, `getResultSet`, and `getUpdateCount` let you navigate through multiple results. The `execute` method executes an SQL statement and indicates the form of the first result. You can then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).
      Specified by:
        `execute` in interface `java.sql.Statement`
      Parameters:
        `sql` - any SQL statement
      Returns:
        `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `getResultSet()`, `getUpdateCount()`, `getMoreResults()`

    - #### executeImpl

          protected boolean executeImpl(java.lang.String sql)
                                 throws java.sql.SQLException

      Internal implementation of `execute(String)`, so it can be used for normal queries and for queries returning generated keys.
      Throws:
        `java.sql.SQLException`
      See Also:
        `execute(String)`

    - #### getResultSet

          public java.sql.ResultSet getResultSet()
                                          throws java.sql.SQLException

      Returns the current result as a `ResultSet` object. This method should be called only once per result. Calling this method twice with autocommit on and used will probably throw an inappropriate or uninformative exception.
      Specified by:
        `getResultSet` in interface `java.sql.Statement`
      Returns:
        the current result as a `ResultSet` object; `null` if the result is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `execute(java.lang.String, int)`

    - #### getResultSet

          public java.sql.ResultSet getResultSet(boolean metaDataQuery)
                                          throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### hasOpenResultSet

          public boolean hasOpenResultSet()

      Description copied from interface: `FirebirdStatement`
      Check if this statement has open result set. Note, this method works correctly if auto-commit is disabled. In auto-commit mode it will always return `false` because from the statement's point of view result set is not open (in auto-commit mode complete result set is fetched and cached in wrapping object before returning from the `Statement.getResultSet()` method).
      Specified by:
        `hasOpenResultSet` in interface `FirebirdStatement`
      Returns:
        `true` if there's already open result set associated with this statement, otherwise `false`.

    - #### getUpdateCount

          public int getUpdateCount()
                             throws java.sql.SQLException

      Returns the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned. This method should be called only once per result.
      Specified by:
        `getUpdateCount` in interface `java.sql.Statement`
      Returns:
        the current result as an update count; -1 if the current result is a `ResultSet` object or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `execute(java.lang.String, int)`

    - #### getDeletedRowsCount

          public int getDeletedRowsCount()
                                  throws java.sql.SQLException

      Description copied from interface: `FirebirdStatement`
      Get number of deleted rows. You can call this method multiple times, it does not affect the JDBC result number.
      Specified by:
        `getDeletedRowsCount` in interface `FirebirdStatement`
      Returns:
        number of deleted rows or -1 if current result is result set.
      Throws:
        `java.sql.SQLException` - if database error occurs.

    - #### getInsertedRowsCount

          public int getInsertedRowsCount()
                                   throws java.sql.SQLException

      Description copied from interface: `FirebirdStatement`
      Get number of inserted rows. You can call this method multiple times, it does not affect the JDBC result number.
      Specified by:
        `getInsertedRowsCount` in interface `FirebirdStatement`
      Returns:
        number of inserted rows or -1 if current result is result set.
      Throws:
        `java.sql.SQLException` - if database error occurs.

    - #### getUpdatedRowsCount

          public int getUpdatedRowsCount()
                                  throws java.sql.SQLException

      Description copied from interface: `FirebirdStatement`
      Get number of updated rows. You can call this method multiple times, it does not affect the JDBC result number.
      Specified by:
        `getUpdatedRowsCount` in interface `FirebirdStatement`
      Returns:
        number of updated rows or -1 if current result is result set.
      Throws:
        `java.sql.SQLException` - if database error occurs.

    - #### getMoreResults

          public boolean getMoreResults()
                                 throws java.sql.SQLException

      Moves to a `Statement` object's next result. It returns `true` if this result is a `ResultSet` object. This method also implicitly closes any current `ResultSet` object obtained with the method `getResultSet`.

      There are no more results when the following is true:

                (!getMoreResults() && (getUpdateCount() == -1)

      Specified by:
        `getMoreResults` in interface `java.sql.Statement`
      Returns:
        `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
      Throws:
        `java.sql.SQLException` - if a database access error occurs
      See Also:
        `execute(java.lang.String, int)`

    - #### getMoreResults

          public boolean getMoreResults(int mode)
                                 throws java.sql.SQLException

      Specified by:
        `getMoreResults` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### setFetchDirection

          public void setFetchDirection(int direction)
                                 throws java.sql.SQLException

      Specified by:
        `setFetchDirection` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### getFetchDirection

          public int getFetchDirection()
                                throws java.sql.SQLException

      Specified by:
        `getFetchDirection` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### setFetchSize

          public void setFetchSize(int rows)
                            throws java.sql.SQLException

      Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed for `ResultSet` objects genrated by this `Statement`. If the value specified is zero, then the hint is ignored. The default value is zero.
      Specified by:
        `setFetchSize` in interface `java.sql.Statement`
      Parameters:
        `rows` - the number of rows to fetch
      Throws:
        `java.sql.SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the condition `rows >= 0` is not satisfied.
      Since:
        1.2
      See Also:
        `getFetchSize()`

    - #### getFetchSize

          public int getFetchSize()
                           throws java.sql.SQLException

      Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object. If this `Statement` object has not set a fetch size by calling the method `setFetchSize`, the return value is implementation-specific.
      Specified by:
        `getFetchSize` in interface `java.sql.Statement`
      Returns:
        the default fetch size for result sets generated from this `Statement` object
      Throws:
        `java.sql.SQLException` - if a database access error occurs or this method is called on a closed `Statement`
      Since:
        1.2
      See Also:
        `setFetchSize(int)`

    - #### getResultSetConcurrency

          public int getResultSetConcurrency()
                                      throws java.sql.SQLException

      Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.
      Specified by:
        `getResultSetConcurrency` in interface `java.sql.Statement`
      Returns:
        either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
      Throws:
        `java.sql.SQLException`
      Since:
        1.2
      See Also:
        What Is in the JDBC 2.0 API

    - #### getResultSetType

          public int getResultSetType()
                               throws java.sql.SQLException

      Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.
      Specified by:
        `getResultSetType` in interface `java.sql.Statement`
      Returns:
        one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
      Throws:
        `java.sql.SQLException`
      Since:
        1.2
      See Also:
        What Is in the JDBC 2.0 API

    - #### getResultSetHoldability

          public int getResultSetHoldability()
                                      throws java.sql.SQLException

      Specified by:
        `getResultSetHoldability` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### addBatch

          public void addBatch(java.lang.String sql)
                        throws java.sql.SQLException

      Adds an SQL command to the current batch of commmands for this `Statement` object. This method is optional.
      Specified by:
        `addBatch` in interface `java.sql.Statement`
      Parameters:
        `sql` - typically this is a static SQL `INSERT` or `UPDATE` statement
      Throws:
        `java.sql.SQLException` - if a database access error occurs, or the driver does not support batch statements
      Since:
        1.2
      See Also:
        What Is in the JDBC 2.0 API

    - #### clearBatch

          public void clearBatch()
                          throws java.sql.SQLException

      Makes the set of commands in the current batch empty. This method is optional.
      Specified by:
        `clearBatch` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException` - if a database access error occurs or the driver does not support batch statements
      Since:
        1.2
      See Also:
        What Is in the JDBC 2.0 API

    - #### executeBatch

          public final int[] executeBatch()
                                   throws java.sql.SQLException

      Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `int` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeBatch` may be one of the following:
      1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
      2. A value of `-2` -- indicates that the command was processed successfully but that the number of rows affected is unknown

         If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

      3. A value of `-3` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

      A driver is not required to implement this method. The possible implementations and return values have been modified in the Java 2 SDK, Standard Edition, version 1.3 to accommodate the option of continuing to proccess commands in a batch update after a `BatchUpdateException` obejct has been thrown.

      Specified by:
        `executeBatch` in interface `java.sql.Statement`
      Returns:
        an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.
      Throws:
        `java.sql.SQLException` - if a database access error occurs or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the commands sent to the database fails to execute properly or attempts to return a result set.
      Since:
        1.3
      See Also:
        What Is in the JDBC 2.0 API

    - #### executeBatchInternal

          protected java.util.List<java.lang.Long> executeBatchInternal()
                                                                 throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### toArray

          protected int[] toArray(java.util.Collection<java.lang.Long> updateCounts)

      Convert collection of `Long` update counts into array of int.
      Parameters:
        `updateCounts` - collection of integer elements.
      Returns:
        array of int.

    - #### toLargeArray

          protected long[] toLargeArray(java.util.Collection<java.lang.Long> updateCounts)

      Convert collection of `Integer` update counts into array of int.
      Parameters:
        `updateCounts` - collection of integer elements.
      Returns:
        array of int.

    - #### getConnection

          public java.sql.Connection getConnection()
                                            throws java.sql.SQLException

      Returns the `Connection` object that produced this `Statement` object.
      Specified by:
        `getConnection` in interface `java.sql.Statement`
      Returns:
        the connection that produced this statement
      Throws:
        `java.sql.SQLException`

    - #### forgetResultSet

          public void forgetResultSet()

    - #### getCurrentResultSet

          public java.sql.ResultSet getCurrentResultSet()
                                                 throws java.sql.SQLException

      Description copied from interface: `FirebirdStatement`
      Get current result set. Behaviour of this method is similar to the behavior of the `Statement.getResultSet()`, except that this method can be called as much as you like.
      Specified by:
        `getCurrentResultSet` in interface `FirebirdStatement`
      Returns:
        instance of `ResultSet` representing current result set or `null` if it is not available.
      Throws:
        `java.sql.SQLException` - if database access error happened.

    - #### isPoolable

          public boolean isPoolable()
                             throws java.sql.SQLException

      Specified by:
        `isPoolable` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### setPoolable

          public void setPoolable(boolean poolable)
                           throws java.sql.SQLException

      Specified by:
        `setPoolable` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### isWrapperFor

          public boolean isWrapperFor(java.lang.Class<?> iface)
                               throws java.sql.SQLException

      Specified by:
        `isWrapperFor` in interface `java.sql.Wrapper`
      Throws:
        `java.sql.SQLException`

    - #### unwrap

          public <T> T unwrap(java.lang.Class<T> iface)
                       throws java.sql.SQLException

      Specified by:
        `unwrap` in interface `java.sql.Wrapper`
      Throws:
        `java.sql.SQLException`

    - #### closeOnCompletion

          public void closeOnCompletion()

      Specified by:
        `closeOnCompletion` in interface `java.sql.Statement`

    - #### isCloseOnCompletion

          public boolean isCloseOnCompletion()

      Specified by:
        `isCloseOnCompletion` in interface `java.sql.Statement`

    - #### isExecuteProcedureStatement

          protected boolean isExecuteProcedureStatement(java.lang.String sql)
                                                 throws java.sql.SQLException

      This method checks if supplied statement is executing procedure or it is generic statement. This check is needed to handle correctly parameters that are returned from non-selectable procedures.
      Parameters:
        `sql` - SQL statement to check
      Returns:
        `true` if supplied statement is EXECUTE PROCEDURE type of statement.
      Throws:
        `java.sql.SQLException` - if translating statement into native code failed.

    - #### internalExecute

          protected boolean internalExecute(java.lang.String sql)
                                     throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### prepareFixedStatement

          protected void prepareFixedStatement(java.lang.String sql)
                                        throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### addWarning

          protected void addWarning(java.sql.SQLWarning warning)

    - #### nativeSQL

          protected java.lang.String nativeSQL(java.lang.String sql)
                                        throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`

    - #### isGeneratedKeyQuery

          protected boolean isGeneratedKeyQuery()

      Returns:
        `true` when the current statement is expected to return generated keys, `false` otherwise.

    - #### getLastExecutionPlan

          public java.lang.String getLastExecutionPlan()
                                                throws java.sql.SQLException

      Description copied from interface: `FirebirdStatement`
      Get execution plan for the last executed statement. Unlike the `FirebirdPreparedStatement.getExecutionPlan()`, this method can be called only after executing a query or update statement.
      Specified by:
        `getLastExecutionPlan` in interface `FirebirdStatement`
      Returns:
        execution plan returned by the server.
      Throws:
        `java.sql.SQLException` - if no statement was executed before calling this method, statement is not valid, or there was an error when obtaining the execution plan.

    - #### checkValidity

          protected void checkValidity()
                                throws java.sql.SQLException

      Check if this statement is valid. This method should be invoked before executing any action which requires a valid connection.
      Throws:
        `java.sql.SQLException` - if this Statement has been closed and cannot be used anymore.

    - #### getLargeUpdateCount

          public long getLargeUpdateCount()
                                   throws java.sql.SQLException

      Specified by:
        `getLargeUpdateCount` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### setLargeMaxRows

          public void setLargeMaxRows(long max)
                               throws java.sql.SQLException

      Jaybird does not support maxRows exceeding `Integer.MAX_VALUE`, if a larger value is set, Jaybird will add a warning to the statement and reset the maximum to 0.

      Specified by:
        `setLargeMaxRows` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### getLargeMaxRows

          public long getLargeMaxRows()
                               throws java.sql.SQLException

      Jaybird does not support maxRows exceeding `Integer.MAX_VALUE`, the return value of this method is the same as `getMaxRows()`.

      Specified by:
        `getLargeMaxRows` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### executeLargeBatch

          public final long[] executeLargeBatch()
                                         throws java.sql.SQLException

      Specified by:
        `executeLargeBatch` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### executeLargeUpdate

          public final long executeLargeUpdate(java.lang.String sql)
                                        throws java.sql.SQLException

      Specified by:
        `executeLargeUpdate` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### executeLargeUpdate

          public final long executeLargeUpdate(java.lang.String sql,
                                               int autoGeneratedKeys)
                                        throws java.sql.SQLException

      Specified by:
        `executeLargeUpdate` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### executeLargeUpdate

          public final long executeLargeUpdate(java.lang.String sql,
                                               int[] columnIndexes)
                                        throws java.sql.SQLException

      Specified by:
        `executeLargeUpdate` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### executeLargeUpdate

          public final long executeLargeUpdate(java.lang.String sql,
                                               java.lang.String[] columnNames)
                                        throws java.sql.SQLException

      Specified by:
        `executeLargeUpdate` in interface `java.sql.Statement`
      Throws:
        `java.sql.SQLException`

    - #### enquoteLiteral

          public java.lang.String enquoteLiteral(java.lang.String val)
                                          throws java.sql.SQLException

      Returns a `String` enclosed in single quotes. Any occurrence of a single quote within the string will be replaced by two single quotes.

      For a dialect 3 database, this will behave exactly like the JDBC 4.3 default implementation. For a dialect 1 database this will quote literals with double quotes and escape double quotes by doubling.

      Parameters:
        `val` - a character string
      Returns:
        A string enclosed by single quotes with every single quote converted to two single quotes
      Throws:
        `java.lang.NullPointerException` - if val is `null`
        `java.sql.SQLException` - if a database access error occurs

    - #### enquoteNCharLiteral

          public java.lang.String enquoteNCharLiteral(java.lang.String val)
                                               throws java.sql.SQLException

      Throws:
        `java.sql.SQLException`
      See Also:
        `enquoteLiteral(String)`

    - #### enquoteIdentifier

          public java.lang.String enquoteIdentifier(java.lang.String identifier,
                                                    boolean alwaysQuote)
                                             throws java.sql.SQLException

      Returns a SQL identifier. If `identifier` is a simple SQL identifier:
      - Return the original value if `alwaysQuote` is `false`
      - Return a delimited identifier if `alwaysQuote` is `true`
      Parameters:
        `identifier` - a SQL identifier
        `alwaysQuote` - indicates if a simple SQL identifier should be returned as a quoted identifier
      Returns:
        A simple SQL identifier or a delimited identifier
      Throws:
        `java.sql.SQLException` - if identifier is not a valid identifier
        `java.sql.SQLFeatureNotSupportedException` - if the datasource does not support delimited identifiers (ie: a dialect 1 database)
        `java.lang.NullPointerException` - if identifier is `null`

    - #### isSimpleIdentifier

          public boolean isSimpleIdentifier(java.lang.String identifier)
                                     throws java.sql.SQLException

      Retrieves whether `identifier` is a simple SQL identifier.
      Parameters:
        `identifier` - a SQL identifier
      Returns:
        true if a simple SQL identifier, false otherwise
      Throws:
        `java.lang.NullPointerException` - if identifier is `null`
        `java.sql.SQLException` - if a database access error occurs

    - #### getLocalStatementId

          public final int getLocalStatementId()

      Description copied from interface: `FirebirdStatement`
      The local statement id is intended to identify the statement for internal implementation purposes.

      NOTE: This method is only included in this interface to try and avoid problems with proxied and bytecode enhanced classes in certain libraries, you should normally have no reason to call this method directly.

      The id is expected - but not guaranteed - to be unique for a single connection, and - preferably - for the entire JVM run time as well.

      Specified by:
        `getLocalStatementId` in interface `FirebirdStatement`
      Returns:
        The local statement id.

    - #### hashCode

          public final int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public final boolean equals(java.lang.Object other)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### createStatementListener

          protected StatementListener createStatementListener()

      Creates the `StatementListener` to be associated with the instance of `FbStatement` created for this `FBStatement` or subclasses.
      Returns:
        instance of `StatementListener`

Copyright © 2001-2021 Jaybird (Firebird JDBC/JCA) team. All rights reserved.